Systemd/extras/keymap/check-keymaps.sh

38 lines
1.1 KiB
Bash
Raw Normal View History

2009-06-17 11:56:52 +02:00
#!/bin/bash
# check that all key names in keymaps/* are known in <linux/input.h>
# and that all key maps listed in the rules are valid and present in
# Makefile.am
SRCDIR=$1
KEYLIST=$2
KEYMAPS_DIR=$SRCDIR/extras/keymap/keymaps #extras/keymap/keymaps
RULES=$SRCDIR/extras/keymap/95-keymap.rules
2009-06-17 11:56:52 +02:00
[ -e "$KEYLIST" ] || {
echo "need $KEYLIST please build first" >&2
exit 1
}
missing=$(join -v 2 <(awk '{print tolower(substr($1,5))}' $KEYLIST | sort -u) <(awk '{print $2}' ${KEYMAPS_DIR}/*|sort -u))
2009-06-17 11:56:52 +02:00
[ -z "$missing" ] || {
echo "ERROR: unknown key names in extras/keymap/keymaps/*:" >&2
2009-06-17 11:56:52 +02:00
echo "$missing" >&2
exit 1
}
# check that all maps referred to in $RULES exist
maps=$(sed -rn '/keymap \$name/ { s/^.*\$name ([^"[:space:]]+).*$/\1/; p }' $RULES)
2009-06-17 11:56:52 +02:00
for m in $maps; do
# ignore inline mappings
[ "$m" = "${m#0x}" ] || continue
[ -e ${KEYMAPS_DIR}/$m ] || {
2009-06-17 11:56:52 +02:00
echo "ERROR: unknown map name in $RULES: $m" >&2
exit 1
}
grep -q "extras/keymap/keymaps/$m\>" $SRCDIR/Makefile.am || {
2009-06-17 11:56:52 +02:00
echo "ERROR: map file $m is not added to Makefile.am" >&2
exit 1
}
done